var gDS;
var gIter;

function Init()
{
  gDS = window.opener.gLastDatasource;
  if (!gDS) return;
  gIter = gDS.GetAllResources();
  generateResourceArcs();
}

function generateResourceArcs()
{
  var output = "";
  for (var t=0; t<20; t++){
    if (gIter.hasMoreElements()){
      var resource = gIter.getNext();
      resource = resource.QueryInterface(Components.interfaces.nsIRDFResource);
      output += resource.Value + "\n";

      var arciter = gDS.ArcLabelsOut(resource);
      while (arciter.hasMoreElements()){
        var arc = arciter.getNext();
        arc = arc.QueryInterface(Components.interfaces.nsIRDFResource);

        var start = "        => " + arc.Value + "  =>  ";
        var spaces = "";
        for (var len = start.length; len>0; len--) spaces += " ";
        var value = RDFGetValue(gDS.GetTarget(resource,arc,true));
        output += start + value.replace(/\n\s*/g,"\n"+spaces) + "\n";
      }
      output += "\n";
    }
    else {
      if (output.length) appendBlock(output);
      return;
    }
  }
  if (output.length) appendBlock(output);
  setTimeout("generateResourceArcs()",0);
}

function appendBlock(output)
{
  var sourceblock = document.getElementById("sourceblock");
  var sourcepre = document.createElementNS("http://www.w3.org/1999/xhtml","pre");
  sourcepre.appendChild(document.createTextNode(output));
  sourceblock.appendChild(sourcepre);
}
